from AccessControl import ModuleSecurityInfo, ClassSecurityInfo
from Products.PythonScripts.Utility import allow_module
from Globals import InitializeClass
from Acquisition import Implicit

from DocumentTemplate.DT_Util import *
from DocumentTemplate.DT_String import String
from DocumentTemplate.DT_Return import DTReturn
from DocumentTemplate import HTML
from Util import error_page

import Filters       

import CoreFuncs

allow_module('Products.PageContract.Scripts')

modulesecurity = ModuleSecurityInfo()
modulesecurity.declarePublic('compile')

class NameSpaceAcqWrap(Implicit): 
    
    def __getitem_(self, key):
        return getattr(self, key)

class ContractObject(Implicit): 
    
    security = ClassSecurityInfo()
    security.declareObjectPublic()
    security.setDefaultAccess(1)
    
    def __init__(self, filters, errors):
        self.filters = filters
        self.e_handlers  = errors
    
    def validate_object(self, context, object):
        pass
    
    def validate_dict(self, context, dict):
        pass
        
    def validate(self, context, strict=0, no_error_handling=0, redirect=0):
        
        """ 
        @context ... not sure about if we get the multi mapping
        @strict
        @no_error_handling
        """
        
        try: r = context['REQUEST'] 
        except: context = NameSpaceAcqWrap().__of__(context)

        errors = CoreFuncs.validate(self.filters[0], self.filters[1], context, strict)
        
        if no_error_handling: return validation_errors
        
        if errors:  ## FIX ME                                       
            handler = self.e_handlers.get(errors[0][0], None)                
            h=''
            

            
            if handler:
                print 'got handler'
                print handler                
                if self.redirect:
                    context['RESPONSE'].redirect(handler)
                else:
                    h=context.getitem(handler)
                    
            elif self.e_handlers.has_key('__default__'):
                print 'got default in contract'
                if redirect:
                    context['RESPONSE'].redirect(
                        self.e_handlers['__default__'])
                else:
                    h=context[self.e_handlers['__default__']]
            else:
                print 'print default'
                h = HTML(error_page)

            if h:
                    context['REQUEST'].RESPONSE.setHeader('Content-Type','text/html')
                    context['REQUEST']['contract_errors']=errors
                    context['REQUEST'].RESPONSE.write(
                        h(context,context,contract_errors=errors))
                    context['RESPONSE'].close()

            # i'm a little unsure about the best overall error
            # handling policy...
            get_transaction().abort()            
            raise TypeError("you can't see the gingerbread man")
        
                 
InitializeClass(ContractObject)    
    
def compile(contract_source, object=None, cache=1):
    """ 
    parse a contract and return a contract object
    
    caveats: the parsing is fairly simple, patches welcome ;)
     
    @contract is the string definition of a contract
    @object is the object that is compiling this contract
    @cache states whether to cache the compiled contract
           on the calling object (if object is given)
    
    """    
    
    if object is not None and hasattr(object, '_v_contractcache'): 
        print 'getting obj from cache'
        cobj = object._v_contractcache.get(hash(contract_source), None)
        if cobj is not None: return cobj
        
    sections = ('#parameters', '#errors')
    
    contract = contract_source.strip()

    contract_lines = contract.split('\n')
    
    cur = None
    cur_section = ()
    res = {}
    
    for l in contract_lines:

        if l.strip()  in  sections:

            if cur is not None:
                res[cur[1:]]='\n'.join(cur_section)
                
            cur = l.strip()
            cur_section = []                

        elif cur:
             cur_section.append(l)
         
        else: raise "Invalid Contract"        

    res[cur[1:]]='\n'.join(cur_section)
        
    print res
        
    if not len(res) >= 1 and len(res) < 3:
           raise SyntaxError("Invalid Contract Syntax 3")
       
    try:
        filters = CoreFuncs.extract_filters([res['parameters']])
        if res.has_key('errors'):
            errors = CoreFuncs.extract_errors([res['errors']])
        else: errors = {}
        
    except Exception, e: 
        import sys
        print 'page contract error', e
        raise SyntaxError('Invalid Contract Syntax during Extraction')

    cobj = ContractObject(filters, errors)

    ## need to unwrap obj
    
    if cache and object is not None:
        store = getattr(object, '_v_contractcache', None)
        if store: store[hash(contract_source)]=cobj
        else: object._v_contractcache = {hash(contract_source):cobj}
        
    return cobj
    
    
modulesecurity.apply(globals())    
